proc insert {start pattern string} {
    set newstart $start.new

    if {[catch {set fp [open $start r]} ]} {
	    set fp [open $start a]
		if {$string!=""} { 
	    	puts $fp $string
   		 }
         close $fp
    } else {
      set matched 0
      set fpnew [open $newstart w]
      while {![eof $fp]} {
         set line [gets $fp]
         if {![string match $pattern $line] && ![eof $fp]} {
            puts $fpnew $line
         } else {
         	if {!$matched} {
				if {$string!=""} { 
		    		puts $fpnew $string
   				 }
                 set matched 1
			}
         }
      }
      close $fp
      close $fpnew
      file rename -force $newstart $start
    }
}


set machine $tcl_platform(os)
set prefix [file join $xmllab $machine]
set xmllab_bin [file join $prefix bin]
set xmllab_lib [file join $prefix lib]

set ld LD_LIBRARY_PATH
if {$machine=="Darwin"} {
   set ld DYLD_LIBRARY_PATH
}

if {$machine=="Darwin" || $machine=="Linux" } {
    if {[catch {set env(PATH)}]} {
        set env(PATH) $xmllab_bin
    } else {
        set env(PATH) $xmllab_bin:$env(PATH)
   }
   if {[catch {set env($ld)}]} {
        set env($ld) $xmllab_lib
    } else {
        set env($ld) $xmllab_lib:$env($ld)
   }
   set TMPDIR [file join $env(HOME) .XMLlab cache]
   set SESSIONDIR [file join $env(HOME) .XMLlab sessions]

} elseif {$machine=="Windows NT"} {
    set env(path) "$xmllab_lib;$xmllab_bin"
	set TMPDIR [file join $env(HOME) XMLlab cache]
    set SESSIONDIR [file join $env(HOME) XMLlab sessions]
}

catch {file mkdir $TMPDIR}
catch {file mkdir $SESSIONDIR}

set XML_CATALOG_FILES "file:///[string map {" " "%20" "\\" "/"} $xmllab]dtd/catalog.xml"
