proc jogloop {f var min max command dt style} {
	set flag "flag$var" 
	set inc "inc$var"
	global $var $flag $inc
	eval $command
	if {[expr $$var+$$inc]>$max} {
		if {$style=="once"} {
			$f.play configure -state normal;
			$f.redo configure -state normal;
			$f.loop configure -state normal;
			return
		} elseif {$style=="replay"} {
			set $var $min
		}  elseif {$style=="loop"} {
			set $var [expr $$var-$$inc]
			set $inc [expr -$$inc]
		}
		set $flag [after $dt "jogloop {$f} {$var} {$min} {$max} {$command} {$dt} {$style}"]
	} elseif {[expr $$var+$$inc]<$min} {
		set $var [expr $$var-$$inc]
		set $inc [expr -$$inc]
		set $flag [after $dt "jogloop {$f} {$var} {$min} {$max} {$command} {$dt} {$style}"]
	} else {
		set $var [expr $$var+$$inc]
		set $flag [after $dt "jogloop {$f} {$var} {$min} {$max} {$command} {$dt} {$style}"]
	}
}

proc jog {f var min max increment command dt} {

	set flag "flag$var" 
	set inc "inc$var"
	global $flag $inc $var
	
    set $flag ""
    
	frame $f
	set $var $min
	set $inc $increment
	Button $f.play -relief flat -width 24 -height 24 -bd 0 -image playImage -command "\
		set $inc $increment;\
		$f.play configure -state disabled;\
		$f.redo configure -state disabled;\
		$f.loop configure -state disabled;\
		jogloop $f $var $min $max {$command} {$dt} once;"
	Button $f.redo -relief flat -width 24 -height 24 -bd 0 -image redoImage -command "\
		$f.play configure -state disabled;\
		$f.redo configure -state disabled;\
		$f.loop configure -state disabled;\
		jogloop $f $var $min $max {$command} {$dt} replay;"
	Button $f.loop -relief flat -width 24 -height 24 -bd 0 -image reloadImage -command "\
		$f.play configure -state disabled;\
		$f.redo configure -state disabled;\
		$f.loop configure -state disabled;\
		jogloop $f $var $min $max {$command} {$dt} loop;"
	Button $f.pause -relief flat -width 24 -height 24 -bd 0 -image pauseImage -command "\
		after cancel $$flag; $f.play configure -state normal;$f.redo configure -state normal;$f.loop configure -state normal"
	pack $f.play $f.redo $f.loop $f.pause -side left
}

proc oldmess { mess } {

   toplevel .dial
   label .dial.mess -text $mess -justify center -font defaultFont
   button .dial.ok -text OK -command {destroy .dial} -font defaultFont -default active
   bind .dial <Return> {.dial.ok invoke}
   pack .dial.mess .dial.ok -padx 3m -pady 3m
   grab set .dial
   tkwait window .dial
}

proc mess { mess } {

	tk_messageBox -message $mess -type ok
}


proc runScilab {bidon} {
	global ok wait lastcmd
	if {$ok == 1} {
		set wait 0
		set ok 0
		ScilabEval exec(xmllab_run,-1)
	} else {
	set wait 1
	}
}

if {[catch {set xmllab}]} {
	set xmllab $env(xmllab)
}

source [file join $xmllab bin tcl env.tcl]
source [file join $xmllab bin tcl xmllablib.tcl]

set auto_path "\"[file join $xmllab_lib]\"\
 \"[file join $xmllab noarch]\" \"[file join $SCI tcl]\" $auto_path" 
  
package require BWidget

image create photo saveImage -file [file join $xmllab noarch images filesave.gif]
image create photo loadImage -file [file join $xmllab noarch images  fileopen.gif]
image create photo deleteImage -file [file join $xmllab noarch images editdelete.gif]
image create photo homeImage -file [file join $xmllab noarch images gohome.gif]
image create photo playImage -file [file join $xmllab noarch images media-play.gif]
image create photo pauseImage -file [file join $xmllab noarch images media-pause.gif]
image create photo redoImage -file [file join $xmllab noarch images redo.gif]
image create photo reloadImage -file [file join $xmllab noarch images reload.gif]
image create photo tearoffImage -file [file join $xmllab noarch images editcopy.gif]

set fontsize 10
if {$tcl_platform(os)=="Windows NT"} {
	set fontsize 8
}

catch {font create defaultFont -family Helvetica -slant roman -size $fontsize -weight normal}
catch {font create mainFont -family Helvetica -slant roman -size $fontsize -weight normal}
catch {font create menuFont -family Helvetica -slant roman -size $fontsize -weight normal}
catch {font create fixedFont -family courier -slant roman -size $fontsize -weight normal}
catch {font create boldFont -family Helvetica -slant roman -size $fontsize -weight bold}
catch {font create bigFont -family Helvetica -slant roman -size $fontsize -weight bold}

option add *Dialog.msg.font {Helvetica 10}
option add *Button.font {Helvetica 10}

