<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:exslt="http://exslt.org/common">

<xsl:output method="xml" indent="no" encoding="ISO-8859-1"/>

<xsl:param name="lang"/>
<xsl:param name="xmllab"/>

<xsl:variable name="version"><xsl:value-of select="document('version.xml')/xmllab/@version"/></xsl:variable>

<xsl:variable name="strings">
	<strings lang="french"
		demos="Dmos XMLlab"
		choose="Choisissez une catgorie"
		cancel="Annuler"
		edit="Editer une simulation"
		run="Excuter une simulation"
		about="A propos de XMLlab"
            uninstall="Dsinstaller XMLlab"
		run_dialog="Selectionner le fichier XML  compiler"
		edit_dialog="Selectionner le fichier XML  diter"
		help="Aide"
		apropos="A propos de XMLlab"
	/>	
    <apropos lang="french">
		<string>Toolbox XMLlab pour Scilab, version <xsl:value-of select="$version"/></string>
		<string/>
		<string>Copyright Stphane Mottelet, Andr Pauss,</string>
		<string>Universit de Technologie de Compigne</string>
		<string>stephane.mottelet@utc.fr, andre.pauss@utc.fr</string>
		<string/>
		<string>XMLlab est distribu sous la licence GPL</string>
		<string>(voir le fichier LICENSE.txt) et est disponible pour</string>
		<string>Linux, MacOSX et Windows,  l'adresse</string>
		<string/>
		<string>http://xmllab.org</string>
    </apropos>
   <uninstall lang="french">
	<string>La Toolbox XMLlab a t dsinstalle avec succs.</string>
      <string>Cliquer sur OK pour quitter Scilab.</string>
  </uninstall>
   <uninstall lang="english">
	<string>The XMLlab Toolbox has been uninstalled.</string>
      <string>Click on OK to quit Scilab.</string>
  </uninstall>
	<strings lang="english"
		demos="XMLlab Demos "
		choose="Choose a category"
		cancel="Cancel"
		edit="Edit a simulation"
		run="Run a simulation"
		about="About XMLlab"
            uninstall="Uninstall XMLlab"
		run_dialog="Select XML file to process"
		edit_dialog="Select XML file to edit"
		help="Help"
		apropos="About XMLlab"
	/>	
    <apropos lang="english">
		<string>XMLlab toolbox for Scilab, version <xsl:value-of select="$version"/></string>
		<string/>
		<string>Copyright Stphane Mottelet, Andr Pauss,</string>
		<string>Universit de Technologie de Compigne</string>
		<string>stephane.mottelet@utc.fr, andre.pauss@utc.fr</string>
		<string/>
		<string>XMLlab is distributed under the GPL licence</string>
		<string>(see the file LICENSE.txt) and is available for</string> 
		<string>Linux, MacOSX and Windows, at the URL</string>
		<string/>
		<string>http://xmllab.org</string>
    </apropos>
</xsl:variable>

<xsl:strip-space elements="*"/>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="publish">
	<sciml>
		<function-definition name="xmllab_demos">
			<body>
				<assign>
					<lhs>xmlab_demos_categories</lhs>
					<rhs>
						<list sep=";">
							<xsl:apply-templates mode="list-of-categories"/>
						</list>
					</rhs>
				</assign>
				<assign>
					<lhs>choice</lhs>
					<rhs>1</rhs>
				</assign>
				<while>
					<condition>choice</condition>
					<do>
						<assign>
							<lhs>choice</lhs>
							<rhs>
								<function-call name="x_choose">
									<inputs>
										<parm>xmlab_demos_categories</parm>
										<parm>
											<list sep=";">
											<parm><string>
												<xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@demos"/>				
											</string></parm>
											<parm><string>
												<xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@choose"/>				
											</string></parm>
											</list>
										</parm>
										<parm>
											<string>
												<xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@cancel"/>				
											</string>
										</parm>			
									</inputs>
								</function-call>
							</rhs>
						</assign>
						<switch expr="choice">
							<xsl:apply-templates select="category" mode="category-switch"/>
						</switch>
					</do>
				</while>
			</body>
		</function-definition>	
		<function-definition name="xmllab_menu">
			<inputs><parm>k</parm></inputs>
			<body>
				<switch expr="k">
					<case value="1">
						<assign>
							<lhs>path</lhs>
							<rhs>
								<function-call name="tk_getfile">
									<inputs>
										<parm>file_mask=<string>*.xml</string></parm>
										<parm>title=<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@run_dialog"/></string></parm>
									</inputs>
								</function-call>
							</rhs>
						</assign>
						<ifthenelse>
							<condition>path~=""</condition>
							<if>
								<macro-call name="xmllab">
									<inputs>
										<parm><string>-run</string></parm>
										<parm>path</parm>
									</inputs>
								</macro-call>
							</if>
						</ifthenelse>
					</case>
					<case value="2">
						<assign>
							<lhs>path</lhs>
							<rhs>
								<function-call name="tk_getfile">
									<inputs>
										<parm>file_mask=<string>*.xml</string></parm>
										<parm>title=<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@edit_dialog"/></string></parm>
									</inputs>
								</function-call>
							</rhs>
						</assign>
						<ifthenelse>
							<condition>path~=""</condition>
							<if>
								<assign>
									<lhs>_lastpath</lhs>
									<rhs>
										<function-call name="dirname">
											<inputs>
												<parm>path</parm>
											</inputs>
										</function-call>
									</rhs>
								</assign>								
								<macro-call name="scipad">
									<inputs>
										<parm>path</parm>
									</inputs>
								</macro-call>
							</if>
						</ifthenelse>
					</case>
					<case value="3">
						<macro-call name="xmllab_demos"/>
					</case>
					<case value="4">
						<macro-call name="help">
							<inputs><parm><string>xmllab</string></parm></inputs>
						</macro-call>
					</case>
					<case value="5">
						<macro-call name="x_message">
							<inputs>
								<parm>
									<list sep=";">
										<xsl:for-each select="exslt:node-set($strings)/apropos[@lang=$lang]/string">
											<parm>
												<xsl:copy-of select="."/>
											</parm>
										</xsl:for-each>
									</list>
								</parm>
							</inputs>
						</macro-call>
					</case>
					<case value="6">
						<!-- Uninstall XMLlab -->
						<macro-call name="xmllab_uninstall">
							<inputs>
								<parm>
									<list sep=";">
										<xsl:for-each select="exslt:node-set($strings)/uninstall[@lang=$lang]/string">
											<parm>
												<xsl:copy-of select="."/>
											</parm>
										</xsl:for-each>
										<parm>
										   <string>
                                                                 <xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@cancel"/>
                                                               </string>
										</parm>
									</list>
								</parm>
							</inputs>
						</macro-call>
					</case>
				</switch>
			</body>	
		</function-definition>
		<macro-call name="delmenu">
			<inputs>
				<parm><string>XMLlab</string></parm>
                  </inputs>
            </macro-call>
		<macro-call name="addmenu">
			<inputs>
				<parm><string>XMLlab</string></parm>
				<parm>
					<list sep=";">
						<parm>
							<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@run"/></string>
						</parm>
						<parm>
							<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@edit"/></string>
						</parm>				
						<parm>
							<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@demos"/></string>
						</parm>				
						<parm>
							<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@help"/></string>
						</parm>		
						<parm>
							<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@apropos"/></string>
						</parm>						
						<parm>
							<string><xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@uninstall"/></string>
						</parm>						
					</list>
				</parm>
				<parm>
					<function-call name="list">
						<inputs>
							<parm>2</parm>
							<parm><string>xmllab_menu</string></parm>
						</inputs>
					</function-call>
				</parm>
			</inputs>
		</macro-call>
	</sciml>
</xsl:template>

<xsl:template match="category" mode="list-of-categories">
	<parm>
		<string>
			<xsl:value-of select="name[@lang=$lang]"/>
		</string>
	</parm>
</xsl:template>

<xsl:template match="category" mode="category-switch">
	<case value="{position()}">
		<assign>
			<lhs>item</lhs>
			<rhs>1</rhs>
		</assign>
		<while>
			<condition>item</condition>
			<do>
				<assign>
					<lhs>item</lhs>
					<rhs>
						<function-call name="x_choose">
							<inputs>
								<parm>
									<xsl:apply-templates select="simulations" mode="list-of-items"/>
								</parm>
								<parm>
									<list sep=";">
									<parm><string>
										<xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@demos"/>				
									</string></parm>
									<parm><string>
										<xsl:value-of select="name[@lang=$lang]"/>				
									</string></parm>
									</list>
								</parm>
								<parm>
									<string>
										<xsl:value-of select="exslt:node-set($strings)/strings[@lang=$lang]/@cancel"/>				
									</string>
								</parm>			
							</inputs>
						</function-call>
					</rhs>
				</assign>
				<switch expr="item">
					<xsl:apply-templates select="simulations" mode="item-switch"/>
				</switch>
			</do>
		</while>
	</case>
</xsl:template>

<xsl:template match="simulations" mode="list-of-items">
	<list sep=";">
		<xsl:apply-templates select="simulation[document(concat(ancestor::category/@dir,'/',@file),/)/simulation/header/title[@lang=$lang]]" mode="list-of-items"/>
	</list>
</xsl:template>

<xsl:template match="simulation" mode="list-of-items">
	<parm>
		<string>
			<xsl:value-of select="normalize-space(document(concat(ancestor::category/@dir,'/',@file),/)/simulation/header/title[@lang=$lang or (not (@lang))])"/>
		</string>
	</parm>
</xsl:template>

<xsl:template match="simulations" mode="item-switch">
	<xsl:apply-templates select="simulation[document(concat(ancestor::category/@dir,'/',@file),/)/simulation/header/title[@lang=$lang]]" mode="item-switch"/>
</xsl:template>

<xsl:template match="simulation" mode="item-switch">
	<case value="{position()}">
		<macro-call name="xmllab">
			<inputs>
				<parm><string>-run</string></parm>
				<parm><string>-lang</string></parm>
				<parm><string><xsl:value-of select="$lang"/></string></parm>
				<parm><string><xsl:value-of select="concat($xmllab,'examples/',ancestor::category/@dir,'/',@file)"/></string></parm>
			</inputs>
		</macro-call>
	</case>
</xsl:template>




</xsl:stylesheet>


